import java.util.Scanner;

import anbxj.*;

public class Tutorial_02 {

	private static String host_server = "127.0.0.1";
	private static int port = 6667;
	private static String usage = "USAGE: java tutorial_02 [client|server]";

	private static String keystorepath = "keystore/";

	public static void main(String[] args) {

		Channel_Properties cp;
		Channel_Settings cs;
		Crypto_KeyStoreSettings_Map kss;
		AnB_Crypto_Wrapper anb;

		switch (args.length) {
		case 1:
			AnBx_Debug.setAppname(Tutorial_02.class.toString() + "-" + args[0]);
			AnBx_Debug.setALL(true);
			if (args[0].equalsIgnoreCase("client")) {

				kss = new Crypto_KeyStoreSettings_Map(keystorepath, "alice");
				cs = new Channel_Settings(Channel_Roles.CLIENT, host_server, port);
				anb = new AnB_Crypto_Wrapper(kss);
				cp = new Channel_Properties(cs);
				new Client_02(anb, cp);
			} else if (args[0].equalsIgnoreCase("server")) {
				kss = new Crypto_KeyStoreSettings_Map(keystorepath, "bob");
				cs = new Channel_Settings(Channel_Roles.SERVER, host_server, port);
				anb = new AnB_Crypto_Wrapper(kss);
				cp = new Channel_Properties(cs);
				new Server_02(anb, cp);
			} else
				System.out.println(usage);
			break;
		default:
			System.out.println(usage);
		}
	}
}

class Client_02 {

	public Client_02(AnB_Crypto_Wrapper anb, Channel_Properties cp) {
		super();

		String secretmsg;
		Channel_Abstraction c = Channel.setup(cp);
		Scanner scanner = new Scanner(System.in);
		
		c.Open();
		String msg = (String) c.Receive();
		System.out.println(msg);
		msg = scanner.nextLine();
		c.Send(msg);
		secretmsg = (String) anb.decrypt((Crypto_SealedPair) (c.Receive()));
		System.out.println(secretmsg);
		c.Close();
		scanner.close();
	}
}

class Server_02 {

	public Server_02(AnB_Crypto_Wrapper anb, Channel_Properties cp) {
		super();
		String name;
		Channel_Abstraction s = Channel.setup(cp);
		do {
			s.Open();
			String msg = new String("Hello! What's your name?");
			s.Send(msg);
			name = (String) s.Receive();
			if (anb.aliasExists(name)) {
				s.Send(anb.encrypt(new String("Hi " + name + "! This message is only for you"), name));
			} else {
				s.Send(new String("Sorry " + name + ", I can't send you a secret message"));
			}
			s.Close();
		} while (true);
	}
}